package lab3_abstract_factory.ex1.house_factories;

import lab3_abstract_factory.ex1.AbstractDoor;
import lab3_abstract_factory.ex1.AbstractWall;
import lab3_abstract_factory.ex1.AbstractWindows;
import lab3_abstract_factory.ex1.HouseFactory;
import lab3_abstract_factory.ex1.doors.ThinDoor;
import lab3_abstract_factory.ex1.walls.WoodWall;
import lab3_abstract_factory.ex1.windows.FramedWindows;

public class SwissWoodChaletFactory extends HouseFactory {
    @Override
    public AbstractWall buildWall() {
        return new WoodWall();
    }

    @Override
    public AbstractWindows buildWindows() {
        return new FramedWindows();
    }

    @Override
    public AbstractDoor buildDoor() {
        return new ThinDoor();
    }
}
