package lab4_command.ex1;

import java.util.HashMap;
import java.util.Map;
import java.util.Stack;

public class Game {
    private final Map<Integer, CarCommand> actions = new HashMap<>();
    private final Stack<CarCommand> history = new Stack<>();
    public Car car;

    public Game() {
        car = new Car();
    }

    public void bindKey(int key, CarCommand command) {
        actions.put(key, command);
    }

    public void unbindKey(int key) {
        actions.remove(key);
    }

    public void pushKey(int key) {
        if (actions.containsKey(key)) {
            CarCommand action = actions.get(key);
            action.execute();
            history.push(action);
        }
    }

    public void undo() {
        if (history.empty()) {
            return;
        }
        history.pop().undo();
    }
}
