package lab4_command.ex2;

import lab4_command.ex2.actions.*;

import java.util.ArrayList;

public class TextEditor {
    private ArrayList<MenuAction> menu = new ArrayList<>();
    private TextFile file;

    public TextEditor(TextFile file) {
        this.file = file;

        addMenuAction(new OpenAction(this.file));
        addMenuAction(new CloseAction(this.file));
        addMenuAction(new SaveAction(this.file));
        addMenuAction(new CopyAction(this.file));
        addMenuAction(new PasteAction(this.file));
    }

    public void clickMenu(int entry) {
        MenuAction action = null;
        try {
            action = menu.get(entry);
        } catch (IndexOutOfBoundsException e) {
            System.out.println("No action bound to entry " + entry);
        }

        if (action != null) {
            action.execute();
        }
    }

    public void addMenuAction(MenuAction action) {
        menu.add(action);
    }

    public void removeMenuAction(int i) {
        menu.remove(i);
    }

    public void setMenuAction(int i, MenuAction action) {
        menu.set(i, action);
    }

    public static void main(String[] args) {
        TextFile file = new TextFile("test.txt");
        TextEditor editor = new TextEditor(file);

        editor.clickMenu(0);
        editor.clickMenu(1);
        editor.clickMenu(2);
        editor.clickMenu(3);
        editor.clickMenu(4);
    }
}
