package lab6_template_method.ex1;

public abstract class Restaurant {
    private String name;
    public Restaurant(String name) {
        this.name = name;
    }

    public final void prepareDinner() {
        serveWater();
        prepareVegetables();
        prepareMainMenu();
        prepareCheese();
        prepareDessert();
        prepareCoffee();
        cleanTable();
    }

    protected void log(String msg) {
        System.out.println("[" + name + "] " + msg);
    }

    protected final void serveWater() {
        log("Serving water");
    }

    protected final void cleanTable() {
        log("Cleaning table");
    }

    protected abstract void prepareVegetables();
    protected abstract void prepareMainMenu();
    protected abstract void prepareCheese();
    protected abstract void prepareDessert();
    protected abstract void prepareCoffee();
}
