package learn.simple_memento;

public class Originator {
    private String state;

    public String getState() {
        return state;
    }

    public void setState(String state) {
        this.state = state;
        System.out.println("[Originator] Setting state to " + state);
    }

    public Memento createMemento() {
        return new Memento(state);
    }

    public void setMemento(Memento memento) {
        state = memento.getSavedState();
        System.out.println("[Originator] State after restoring from memento: " + state);
    }

    public class Memento {
        private final String state;

        public Memento(String state) {
            this.state = state;
        }

        public String getSavedState() {
            return state;
        }
    }
}
