package learn.simple_state;

public class Context {
    private State onState;
    private State offState;

    private State currentState;

    public Context() {
        onState = new OnState(this);
        offState = new OffState(this);
        currentState = offState;
    }

    public void setCurrentState(State currentState) {
        this.currentState = currentState;
    }

    public State getOffState() {
        return offState;
    }

    public State getOnState() {
        return onState;
    }

    public void on() {
        currentState.on();
    }

    public void off() {
        currentState.off();
    }
}
